**==morlev.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      SUBROUTINE MORLEV(DELE,JMAX,WE,XE,IR,NMAX,zpe)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C
C
C	CALCULATES ENERGY LEVELS FOR MORSE OSCILLATOR TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain
c	JMAX	= index of Emax
c	WE	= harmonic vibration frequency (cm-1)
c	XE	= anharmonicity (cm-1)
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array (e.g. dissociation energy for Morse Osc.)
c       zpe     = zero point energy (cm-1), including anharmonicity
c
C	Input OBSERVED WEo = WE + 2*XE for 0-1 transition
c	Note sign of XE:  negative for usual Morse Oscillator
c
c	E = WE*(v+1/2) + XE*(v+1/2)^2
C
C     ALL ENERGIES AND FREQUENCIES IN WAVENUMBERS, relative to ZPE = WE/2 + XE/4
C
c    2/02 Modification: now, hindered rotors are counted as vibs in Whitten-Rabinovitch
c         parameter calculations. Zero point energy is calculated based on anharmonic
c         vibrations and from the hindered rotor subroutine.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      EXTERNAL STERAB , GAM , WRAB , WRDEN , ALNGAM
      DIMENSION IR(20001)
      SAVE 
 
      IF ( XE.LT.0.0 ) THEN
         RMAX = 0.5D+00*(-WE/XE+1.D+00)                 ! Maximum bound level
      ELSE
         RMAX = JMAX*DELE/WE                            ! Maximum bound level
      ENDIF
      NMAX = INT(RMAX) + 1
      IF ( NMAX.GT.20001 ) NMAX = 20001
      zpe = 0.5d+00*WE + 0.25d+00*XE                    ! Zero point energy
      DO 100 I = 1 , NMAX
         IF ( XE.LT.0.0D+00 ) THEN
            R = DBLE(I)*(WE+(1.D+00+DBLE(I))*XE)/DELE   ! Relative to ZPE = WE/2 + XE/4
         ELSE
            R = WE*I/DELE                               ! Harmonic
         ENDIF
c      IR(I) = INT(R) + 1				! Truncation: number of grains
      IR(I) = IDNINT(R)                                 ! Nearest integer: number of grains
 100  CONTINUE
 
      RETURN
      END
