**==rotlev.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      SUBROUTINE ROTLEV(DELE,JMAX,B,NSYMM,NDIM,IR,NMAX)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c    Last modified:
c
c    8/01 BUG FIX: fixed 1-D rotor levels: replaced B*J*(J+1) with B*J*J
c    5/99 by J. R. Barker
CC
C	CALCULATES ENERGY LEVELS FOR FREE ROTOR TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain size
c	JMAX	= index of Emax
c	B	= rotational constant (cm-1)
c       NSYMM   = rotor symmetry number (foldedness)
c	NDIM	= rotor dimension
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array
c
c       NOTE: this subroutine calculates the actual energy levels, skipping the
c             levels not permitted for a given symmetry number. Hence the level
c             spacing is approximately B*NSYMM*J^2, instead of B*J^2.
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION IR(20001)
      SAVE 
 
      BB = B*NSYMM
      RMAX = SQRT(JMAX*DELE/BB)  ! Maximum bound level
      NMAX = INT(RMAX) + 2
      IF ( NMAX.GT.20001 ) NMAX = 20001
 
      DO 100 J = 1 , NMAX
         K = J
         IF ( NDIM.EQ.1 ) THEN
             R = BB*K*K/DELE
           ELSE
             R = BB*K*(K+1.0D+00)/DELE
         ENDIF
c         IR(J) = INT(DINT(R)) + 1       ! Truncate
         IR(J) = IDNINT(R)              ! Nearest integer: number of grains
 100  CONTINUE
 
      RETURN
      END
