**==aa0001.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
c	Declarations
c
c	Isize	= size of double array
c	MaxWell	= maximum number of wells
c	MaxProd = maximum of product sets
c	MaxChan	= maximum number of reaction channels from any given well
c	MaxRxn	= maximum number of reactions, summed over all wells
c       Jsize   = size of the cumulative initial energy distribution
c
c   MAXIMUM SIZE OF SYSTEM CAN BE CHANGED BY CHANGING PARAMETER DECLARATIONS
c
      INTEGER Isize , MaxWell , MaxProd , MaxChan , MaxRxn , Jsize
      PARAMETER (Isize=500,MaxWell=15,MaxProd=25,MaxChan=25,MaxRxn=76,
     &           Jsize=500)
c
c
c	Input/output unit numbers
c
      INTEGER KIN , KOUT , KTXT , KARY , KDIST , KRAT , KSTD , KFLX ,
     &               KSMM
      COMMON /UNIT  / KIN , KOUT , KTXT , KARY , KDIST , KRAT , KSTD , 
     &                KFLX , KSMM
c
c
c	Energy grains and maximum energies for double arrays (cm-1)
c
      DOUBLE PRECISION Egrain1 , Egrain2 , Emax1 , Emax2
      INTEGER imax1
      COMMON /ENERGY/ Egrain1 , Emax1 , Emax2 , Egrain2 , imax1
c
c
c	NWells	= number of wells in a given calculation
c	NProds	= number of product sets in a given calculation
c	IMol	= index number of any given molecule
c	SMol	= vibrational modes of a molecule
c	RotMol	= rotational modes of a molecule
c	Molsym	= symmetry number of a given molecule
c	Molele	= electronic degeneracy of a given molecule
c	Molopt	= number of optical isomers of a given molecule
c	Iread	= flag for reading densities of states from an external file
c	HMol	= enthalpy (actually internal energy) of a molecule
c	ZPEMol	= zero point energy of a given molecule
c	BetMol	= Whitten-Rabinovitch parameter for a given molecule
c	HvMol	= geometric mean frequency of a given molecule
c	MolMom	= moment of inertia for 2-D external rotation of a given molceule
c	MolName	= name of a given molecule
c	Viblo	= lowest vibrational frequency in Mol
c
      INTEGER NWells , NProds , IMol , SMol , RotMol , Molsym , Molele , 
     &        Molopt , Iread
      DOUBLE PRECISION HMol , ZPEMol , BetMol , HvMol , MolMom , Viblo
      CHARACTER MolName*10 , LJQM*2 , LJ*2 , QM*2
      PARAMETER (LJ='LJ',QM='QM')
      COMMON /MOL   / HMol(MaxWell) , ZPEMol(MaxWell) , BetMol(MaxWell)
     &                , HvMol(MaxWell) , MolMom(MaxWell) , 
     &                Viblo(MaxWell) , IMol(MaxWell+MaxProd) , 
     &                SMol(MaxWell) , RotMol(MaxWell) , Molsym(MaxWell)
     &                , Molele(MaxWell) , Molopt(MaxWell) , 
     &                Iread(MaxWell) , NWells , NProds
      COMMON /MOLC  / MolName(MaxWell+MaxProd) , LJQM(MaxWell)
c
c
c	Jto	= index number of product molecule
c	Jrev	= flag for reversible reaction
c	Nchan	= number of rxn channels from a given molecule
c	TSsym	= symmetry number of a transiton state
c	TSele	= electronic degeneracy of a transition state
c	TSopt	= number of optical isomers of a transition state
c	Jread	= flag for reading sums, or k(E)'s from an external file
c	Afac	= A-factor used with Inversle Laplace Transform method
c	Eo	= critical energy for a reaction channel
c       Eor     = critical energy for a reaction channel, corrected for rotational energy
c	Hts	= enthalpy (internal energy) of a transition state
c       NCENT   = flag for applying quasi-diatomic centrifugal correction
c	TSmom	= moment of inertia for 2-D external rotation of a transition state
c	TSname	= name of a transition state
c
      INTEGER Jto , Jrev , Nchan , TSsym , TSele , TSopt , Jread , NCENT
      DOUBLE PRECISION Afac , Eo , Eor , Hts , TSmom
      CHARACTER*10 TSname
      COMMON /RXN   / Afac(MaxWell,MaxChan) , Eo(MaxWell,MaxChan) , 
     &                Eor(MaxWell,MaxChan) , 
     &                Hts(MaxWell,MaxChan) , TSmom(MaxWell,MaxChan) , 
     &                Jto(MaxWell,MaxChan) , Nchan(MaxWell) , 
     &                Jrev(MaxWell,MaxChan) , TSsym(MaxWell,MaxChan) , 
     &                TSele(MaxWell,MaxChan) , TSopt(MaxWell,MaxChan) , 
     &                Jread(MaxWell,MaxChan) , NCENT(MaxWell,MaxChan)
      COMMON /RXNC  / TSname(MaxWell,MaxChan)
c
c
c	CollK	= bimolecular collision frequency rate constant
c	Dens	= density of states for molecule Mol
c	Rate	= k(E) for a given molecule and channel
c
      DOUBLE PRECISION CollK , Dens , Rate , Path
      COMMON /RATE  / CollK(MaxWell) , Dens(MaxWell,Isize) , 
     &                Rate(MaxWell,MaxChan,Isize) , 
     &                Path(MaxWell,MaxChan)
c
c
c	DC	= coefficients defining a collision model
c	COLLUP	= probability of an up-step
c	CNORM	= normalization factor for collision model
c	CE	= coefficients for inelastic transition probability
c	IDUM	= random number seed
c	ITYPE	= flag designating collision model type
c
      DOUBLE PRECISION DC , COLLUP , CNORM , CE
      INTEGER IDUM , ITYPE
      CHARACTER LI*100
      COMMON /COLL  / COLLUP(MaxWell,Isize) , CNORM(MaxWell,Isize) , 
     &                DC(MaxWell,8) , CE(MaxWell,3) , ITYPE(MaxWell) , 
     &                IDUM
      COMMON /COLLC / LI(MaxWell,5)
c
c
c	Pstart	= Normalized cumulative distrib. of starting energies
c	Hstart	= Energy step size for initial energy distribution Pstart
c	Nstart	= actual starting energies selected via random number
c
      DOUBLE PRECISION Pstart , Hstart , Edels
      INTEGER Nstart
      COMMON /START / Pstart(Jsize) , Nstart(Jsize) , Hstart , Edels
c
c
c	Rab(i) are the unimolecular reaction rates and collision
c	frequency calculated in STEPPER and used in BOOK1
c
      DOUBLE PRECISION Rab
      COMMON /BOSTEP/ Rab(MaxChan+1)
