**==etherm.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      DOUBLE PRECISION FUNCTION Etherm(Mol,T)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2002 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      INTEGER Mol
      DOUBLE PRECISION Q , T , E , ET , Term , Test , H , DENVR , 
     &                 Tlast , Elast
      EXTERNAL DENVR
      SAVE 
c
c	Average thermal energy of Mol at temperature T
c
c	Uses numerical integration of densities of states.
c
      IF ( SMol(Mol).LT.1 ) THEN
         Etherm = 0.0D+00
         RETURN
 
      ELSE
         ET = 0.0D+00
         Q = 0.0D+00
         Elast = 0.0D+00
         Tlast = 0.0D+00
         H = Egrain1
         E = -H
         Test = 1.0
         DO WHILE ( Test.GT.1.0E-08 )
            E = E + H
            Term = DENVR(Mol,E)*exp(-1.4388*E/T)
            Q = Q + 0.5*H*(Tlast+Term)                  ! Trapezoidal rule
            ET = ET + 0.5*H*(Elast*Tlast+E*Term)        ! Trapezoidal rule
            Tlast = Term
            Elast = E
            IF ( E.GT.10.*T ) Test = E*Term/ET
         ENDDO
 
         Etherm = ET/Q
         RETURN
      ENDIF
 
      END
