**==fcoll.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      DOUBLE PRECISION FUNCTION Fcoll(Mol,E)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	When using total collision rates (LJQM = QM), fraction of inelastic
c	collisions.  When using Lennard-Jones collision frequency, Fcoll = 1.
c
c	Fcoll is a heuristic function to account for the variation of the
c	fraction at low vibrational energies
c
 
      IMPLICIT NONE
 
      INCLUDE 'declare1.inc'
 
      INTEGER Mol
 
      DOUBLE PRECISION E
 
      SAVE 
 
      IF ( LJQM(Mol).EQ.LJ ) THEN
         Fcoll = 1.0D+00
      ELSEIF ( LJQM(Mol).EQ.QM ) THEN
         Fcoll = CE(Mol,1)*(1.0D+00-exp(-(E+CE(Mol,3))/CE(Mol,2)))
      ENDIF
 
      RETURN
 
      END
