**==qudint.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      SUBROUTINE QUDINT(Y1,Y2,Y3,X,Y)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c***********************************************************************
C
C     LINEAR/QUADRATIC INTERPOLATION FROM EQUALLY-SPACED DATA, RETURNING
C	VALUE OF Y AT VALUE OF X:
C
C       Y1 AT X = -1
C       Y2 AT X =  0
C       Y3 AT X = +1
C
C	IF Y1=Y2, OR Y2=Y3, USE LINEAR TO PREVENT "OVERSHOOT";
C		 OTHERWISE, USE QUADRATIC
C
C       QUADRATIC FORM:  Y = A*X**2 + B*X + C
C
c***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
 
      TEST1 = ABS(Y1-Y2)
      TEST2 = ABS(Y3-Y2)
 
      IF ( TEST1.GT.1.E-06 .AND. TEST2.GT.1.E-06 ) THEN                 ! Quadratic interpolation
         C = Y2
         B = 0.5*(Y3-Y1)
         A = 0.5*(Y1+Y3) - Y2
         Y = (A*X+B)*X + C
      ENDIF
 
      IF ( TEST1.LT.1.E-06 .AND. X.LE.0.0 ) THEN        ! Linear interpolation
         Y = Y2
      ELSE
         Y = Y2 + X*(Y3-Y2)
      ENDIF
 
      IF ( TEST2.LT.1.E-06 .AND. X.GE.0.0 ) THEN        ! Linear interpolation
         Y = Y2
      ELSE
         Y = Y2 - X*(Y1-Y2)
      ENDIF
 
      RETURN
      END
