c      Emulation of John Barker's UNIX/Linux runtest (for Thermo)
c      for Windows. To be compiled with g77.
c      V1.0 23-Oct-2003

       program runtest

       external Fdate  
       
       character*255 working_directory,
      2              date,
      3              answer*1

       write(6,fmt='('' '')')
       write(6,fmt='(''Testing Thermo'')')
       call fdate(date)
       write(6,fmt='(a)')date(1:lenstr(date))
       write(6,fmt='(''Running Thermo'')')

       call system('..\\thermo',istatus)
       if(istatus.ne.0)then
           write(6,fmt='(''system failed, status='',i4)')istatus
           stop
       endif

       write(6,fmt='(''done'')')
       write(6,fmt='('' '')')
       answer='A'
       do while(answer.ne.'Y'.and.answer.ne.'N')
10         write(6,fmt='(''Would you like to compare the output '',
      2    ''versus the test output [y/n]? '',$)')
           read(5,fmt='(a)',err=10)answer
           call upper(answer)
           if(answer.ne.'Y'.and.answer.ne.'N')then
               write(6,fmt='(''Answer y or n.'')')
           endif
       enddo
       if(answer.eq.'N')then
           write(6,fmt='(''Finished'')')
           stop
       else
           write(6,fmt='('' '')')
           write(6,fmt='(''Running diff'')')
c
c          Requires diff.exe in the multiwell top-level directory.
c
           call system
      2    ('..\\..\\..\\diff thermo.out thermo.out.test',istatus)
           if(istatus.gt.1)then
               write(6,fmt='(''system failed, status='',i4)')istatus
               stop
           endif
           write(6,fmt='(''Finished'')')

       endif

       stop
       end
c
      function lenstr(string)
c
      implicit      none
c
      character*(*) string,  !input string
     2              null*1   !null character
c
      integer*4     i,       !string index
     2              iend,    !candidate for string length
     3              j,       !index used for stepping through string
     4              length,  !defined length of input
     5              lenstr   !length of string
c
      length=len(string)
c
c     Look for the existence of nulls; if there
c     are any, the first one marks one character past the
c     end of the defined string. If there are no nulls,
c     pick up the final nonspace character, and call that
c     the defined length of the string.
c
      null=char(0)
c
c     Look for nulls
c
      iend=index(string(1:length),null)
c
c     No nulls, look for the location of the last nonspace.
c
      if(iend.eq.0)then
          do i=1,length
              j=length+1-i
              if(string(j:j).ne.' ')then
                  lenstr=j
                  return
              endif
          enddo
c
c         all spaces
c
          lenstr=0
          return
      else
c
c         first null-1
c
          lenstr=iend-1
          return
      endif
      end
c
c     Converts any lowercase characters in an arbitrary string to uppercase.
c
      subroutine upper(string)
      character*(*) string,lowers*26,uppers*26
c
      lowers='abcdefghijklmnopqrstuvwxyz'
      uppers='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
c
c     Convert to upper case, if necessary.
c
      do i=1,len(string)
          n=index(lowers,string(i:i))
          if(n.ne.0)string(i:i)=uppers(n:n)
      enddo
      return
      end
